#!/etc/opt/openit/perl
use strict;
use warnings;

my $total_usage = "/var/opt/openit/etc/filtrator/licenseevents-total-usage.conf";
my $user_groups = "/var/opt/openit/etc/filtrator/licenseevents-usergroups.conf";
my $individual_usage = "/var/opt/openit/etc/filtrator/licenseevents-individual-usage.conf";
my $host_usage = "/var/opt/openit/etc/filtrator/licenseevents-host-usage.conf";
my $host_groups = "/var/opt/openit/etc/filtrator/licenseevents-hostgroups.conf";

update_filter( $total_usage );
update_filter( $user_groups );
update_filter( $individual_usage );
update_filter( $host_usage );
update_filter( $host_groups );


sub update_filter {
	# body...
	my ($filter) = @_;
	chomp $filter;
	$filter =~ s/^\s+|\s+$//g;
	print( "Reading $filter\n" );
	
	open(FILE, $filter) or die "Unable to read filter file '$filter'";
	my @lines = <FILE>;
	close FILE;

	if( grep {/Summarize:duplicates/} @lines ) {
		print "Filter '$filter' already updated.\n";
		return;
	}

	my $index = 0;
	$index++ while( $lines[$index] !~ /filter-process/ );
	$index += 2;

	my @insert = ("\t\tSummarize:duplicates()=\"\"\n", "\t\t{\n");
	splice @lines, $index, 0, @insert;
	$index += 2;

	$index++ while( $lines[$index] !~ /filter-defs/ );
	splice @lines, $index-2, 0, "\t\t}\n";
	$index += 3;

	@insert = ("\t\tSummarize:duplicates()=\"\"\n",
		"\t\t{\n".
		"\t\t\tinactive(Bool)=\"false\"{}\n",
		"\t\t\tfilter(String)=\"Summarize\"{}\n",
		"\t\t\talign(TimeSpan)=\"PT0\"{}\n",
		"\t\t\tcompare(String)=\"start,duration,product,feature,feature_version,host,user\"{}\n",
		"\t\t\tsummarize(String)=\"var6\"{}\n",
		"\t\t\tlimit(String)=\"\"{}\n",
		"\t\t}\n"
		);
	splice @lines, $index, 0, @insert;

	my $tmp = "$filter.tmp";
	my $old = "$filter.old";

	open( OUT, ">$tmp" ) or die "Unable to create temp file '$tmp'\n";
	print OUT @lines;
	close OUT;

	if ( ! rename $filter, $old ) {
		die "Unable to backup '$filter\n'";
	}

	if ( ! rename $tmp, $filter ) {
		die "Unable to update '$filter\n'";
	}
	print("Done updating $filter\n");
}
